/* Color.cpp provides the implementation of class Color operations
 * ...
 ****************************************************************/

#include "Color.h"                                     // class Color
#include <string>                         // string
//#include <cstdlib>                        // exit()
#include <cctype>                         // islower(), toupper
using namespace std;

// ------- Input Method ----------------------------------
void Color::read(istream& in)
{
   string colorString;                                // read string
   in >> colorString;

   for (int i = 0; i < colorString.size(); i++)       // convert case
      if (islower(colorString[i]))                    // if needed
         colorString[i] = toupper(colorString[i]);

   if (colorString == "RED")                          // map to ColorValue
      myColorValue = RED;
   else if (colorString == "ORANGE")
      myColorValue = ORANGE;
   else if (colorString == "YELLOW")
      myColorValue = YELLOW;
   else if (colorString == "GREEN")
      myColorValue = GREEN;
   else if (colorString == "BLUE")
      myColorValue = BLUE;
   else if (colorString == "INDIGO")
      myColorValue = INDIGO;
   else if (colorString == "VIOLET")
      myColorValue = VIOLET;
   else
   {
      cerr << "\n*** read(): invalid color-value received!\n";
      in.setstate(ios::failbit);
   }
}

// ------ Output Method -----------------------------------------
void Color::print(ostream& out) const
{
  switch(myColorValue)
  {
    case RED:     out << "RED";
                  break;
    case ORANGE:  out << "ORANGE";
                  break;
    case YELLOW:  out << "YELLOW";
                  break;
    case GREEN:   out << "GREEN";
                  break;
    case BLUE:    out << "BLUE";
                  break;
    case INDIGO:  out << "INDIGO";
                  break;
    case VIOLET:  out << "VIOLET";
                  break;
  }
}



// ------- Wavelength --------------------------------------------
double Color::wavelength() const
{
   switch (myColorValue)
   {
      case RED:
                   return 6.5E-7;
      case ORANGE:
                   return 6.0E-7;
      case YELLOW:
                   return 5.8E-7;
      case GREEN: 
                   return 5.2E-7;
      case BLUE:
                   return 4.7E-7;
      case INDIGO:
                   return 4.4E-7;
      case VIOLET:
                   return 4.1E-7;

	  default:

		  return 0.0;
   }
}

// -------- Prefix Increment --------------------------------------
Color Color::operator++()
{
   switch(myColorValue)
   {
      case RED:    
                   myColorValue = ORANGE;
                   break;
      case ORANGE: 
                   myColorValue = YELLOW;
                   break;
      case YELLOW: 
                   myColorValue = GREEN;
                   break;
      case GREEN:  
                   myColorValue = BLUE;
                   break;
      case BLUE:   
                   myColorValue = INDIGO;
                   break;
      case VIOLET: 
                   myColorValue = COLOR_OVERFLOW;
                   break;
   }

   return Color(myColorValue);
}

// -------- Postfix Increment -------------------------------------
Color Color::operator++(int)
{
   Color myOriginalColor(myColorValue);

   switch(myColorValue)
   {
      case RED:    
                   myColorValue = ORANGE;
                   break;
      case ORANGE: 
                   myColorValue = YELLOW;
                   break;
      case YELLOW: 
                   myColorValue = GREEN;
                   break;
      case GREEN:  
                   myColorValue = BLUE;
                   break;
      case BLUE:   
                   myColorValue = INDIGO;
                   break;
      case INDIGO: 
                   myColorValue = VIOLET;
                   break;
      case VIOLET: 
                   myColorValue = COLOR_OVERFLOW;
                   break;
   }

   return myOriginalColor;
}
